

<?php
/*
 * Using API example script
 */  
?>

<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-type" content="text/html; charset=UTF-8" />
        <meta http-equiv="Content-Language" content="en-us" />
        <title>Questblue.com - Using API example</title>
    </head>
    <body> 

        <h1>Getting started</h1>
        <ul>
            <li>Login into your account on customer.questblue.com and send <a href="https://customer.questblue.com/serviceapi">API access request;</a></li>
            <li>On getting API access approval (you will receve Email notification) copy your Private Access Key on customer.questblue.com/serviceapi;</li>
            <li>Configure config.inc.php file with your customer.questblue.com Login name, Password and Private Access Key.<br />Set connection type - curl or socket depending on your server the configuration (curl by default);</li>
            <li>See sourche of the file and uncomment required API options;</li>
            <li>Upload API files into your server (which runs on IP address you specified when you requested access to the API);</li>      
            <li>Enjoy!</li>
        </ul>
        
        <a target="_blank" href="https://customer.questblue.com/docs/show/apidocs">API documentation</a> 


<?php
require_once dirname(__FILE__) . '/config.inc.php';
include dirname(__FILE__) . '/qbapi.class.php';

$api = new QBapi();


// -------------- Test API connection --------------------- //
$result = $api->testApiConnect(); 


// -------------- Show your current IP address --------------------- //
 $result = $api->myIP(); 


/*
 * Managing SIP accounts
 */

// -------------- Create new SIP trunk --------------------- //
//$result = $api->createSipTrunk('myTrunk222', '9.9.9.14'); // Ctrate static trunk
//$result = $api->createSipTrunk('myTrunk'); // create registration trunk, you must be allowed by admin to create the type/

//$result = $api->createSipTrunk('myTrunk', '9.9.9.9', 'myPassword', array('sipSetDdns', 'trunk' => 'myTrunk', 'host'=> 'host.com') ); //add custom registration  password, use Cllback to check DNS
//$result = $api->createSipTrunk('myTrunk', '', 'myPassword', array('routeDID',  'trunk'=> 'myTrunk', 'did' => '8552010059') ); // Use Callback to route DID
//$result = $api->createSipTrunk('myTrunk', '', 'myPassword', array('sipSetInterCalls', 'trunk'=> 'myTrunk', 'action' => 'on' ) ); // Use Callback to enable Interbational calls



// -------------- Registered SIP trunk(s) property --------------------- //
//$result = $api->listSipTrunks();   // List all Sip accounts
//$result = $api->listSipTrunks('trunk4');  // List one account
//$result = $api->listSipTrunks( array('trunk1', 'trunk4') ); // List multi accounts


 // -------------- Enable / Disable  failover IP address --------------------- //
/*
failover_ip_address - IP address to set on having timeout errors 
failover_offline_call_num - Number offline calls within time range 
failover_offline_time - Time interval  (minutes) to check offlile calls. Allowable values: 3, 5, 7, 10, 15, 20, 30 
*/
//$result = $api->sipFailoverIp('trunk1', 'enable', array('8.8.8.9', 2, 3) );  
//$result = $api->sipFailoverIp('trunk1', 'disable'); 


// -------------- Allow / Disallow international calls --------------------- //
//$result = $api->sipSetInterCalls('testTrunk123' , 'off');   // Turn ON  International Calls
//$result = $api->sipSetInterCalls('trunk1' , 'off');  // Turn OFF International Calls


// -------------- Enable / Disable Dynamic DNS  --------------------- //
//$result = $api->sipSetDdns('myTrunk' );   

// -------------- Enable / Disable Trunk Forwarding  --------------------- //
//$result = $api->sipSetForward('helloWorld',  '1234567891');   
//$result = $api->sipSetForward('helloWorld'); 
   
// -------------- Assign (route) new IP address to SIP trunk --------------------- //
//$result = $api->updateSipIp('trunk2', '4.4.4.4');     


// -------------- Lock SIP trunk --------------------- //
//$result = $api->lockSipTrunk('trunk2');


// -------------- unLock SIP trunk --------------------- //
//$result = $api->unlockSipTrunk('trunk2');


// -------------- Delete SIP trunk --------------------- //
//$result = $api->deleteSipTrunk('HelloRegMonte4');


// -------------- Call History --------------------- //
/* 
 * SIP Trunk to retrieve
    all (string) - All trunks
     trunkName (string) - Define single SIP trunk name
     trunkName1, trunkName2 (array) -  array of trunks
 * Date ranges to see stat. Values: 
    0(default) - current hour (EDT), 
    1 - previous hour (EDT),  
    2 - today, 
    3 - yesterday, 
* array(dateTime start, dateTime end) - date time range
* Type of calls. Values: 
    0 (default) - All calls, 
    1 - Inbound calls, 
    2 - Outbound calls
* Sow_empty CDR - Whether to show unsuccessful CDRs in a a query result. 
    no - do not show unsuccessful calls. By default
    yes - show all calls
* Retieve specific DID INbound or OUTbound
    all (string) - All DIDs
    DID (string) - Define single DID 
    DID1, DID2 (array) -  array of DIDs
 * Summary only - disaplay call summary only
     yes / no
 */




//$result = $api->callHistory('all', 0, 0, 'no', 'all', 'yes');
//$result = $api->callHistory( 'all', array('2018-10-29 00:03:31', '2018-10-29 22:00:00'), 0);
//$result = $api->callHistory( "all", array("2019-01-16 00:00:01", "2019-01-17 23:59:59") );
//$result = $api->callHistory( array('trunk1', 'trunk2'), array('2018-05-01 02:03:31', '2018-05-31 22:00:00'), 0, 'yes' );
//$result = $api->callHistory( 'all', array('2018-05-01 02:03:31', '2018-05-31 22:00:00'), 0, 'yes', 3368811040 );
//$result = $api->callHistory( 'all', array('2018-05-01 02:03:31', '2018-05-31 22:00:00'), 0, 'yes'  );

//$result = $api->callHistory('Armortech',1,0,'no','7274473789','no');

//$result = $api->callHistory( 'Armortech', array('2019-04-23 10:00:00', '2019-04-23 11:00:00'), 0, 'no', '7274473789','no' );  // Client
                // callHistory($trunk, $period = 0,                                    $type, $show_empty = 'no', $did = 'all', $summary_only = 'no', $min_id = '')
//$result = $api->callHistory( 'all', array('2019-04-24 09:00:00', '2019-04-24 22:00:00'), 0, 'no', 'all','no', 199128724);  // AIP
//echo '<pre>';
//var_dump($result);
//print_r($result);
//die;
/*
 * Managing DIDs
 */

// -------------- List US states (to get Rate center) --------------------- // 
//$result = $api->listStates();


// -------------- Get Rate Centers list by a State --------------------- //
//$result = $api->listRateCenters('NC', '1b'); // List rate centers in North Carolina


// -------------- Get Local DIDs List --------------------- //
// You should use $ratecenter/$state or $npa to get DIDs list
//$result = $api->listAvailableLocalDIDs('DURHAM', 'NC', '', '1'); // DIDs by rate center and state. Allowed tier values : 1, 1b, 2
//$result = $api->listAvailableLocalDIDs(null, null, 505, '1b'); // DIDs by NPA or ZIP code. Search by ZIP code available to tier 1b only
//$result = $api->listAvailableLocalDIDs(null, null, 27513, '1b'); // DIDs by ZIP code.  Search by ZIP code available to tier 1b only



// -------------- Get Toll Free DIDs List --------------------- //
//$result = $api->listAvailableTfDIDs('1b', '84'); //Allowed tier values : 1, 1b, code: 80, 84, 85, 86

// -------------- Order Local or Toll Free DID --------------------- //
//$result = $api->orderDID(9193233766, '1b', 'verazo test DID'); //Allowed Tier values : 1, 1b, 


// -------------- Set add/remove DID Note --------------------- //
//$result = $api->setDidNote(1234567890,  'my DID note'); 


// -------------- Set Caller ID to DID --------------------- //
//$result = $api->setLidb(1234567890, 'Support Dep2'); //  


// --------------  Ordered DID(s) properties --------------------- //
//$result = $api->propertyDid(); // All ordered DIDs
//$result = $api->propertyDid(9143520733); // Single DID
//$result = $api->propertyDid( array(1234567890, 1234567891) ); // DIDs array
 

// --------------  Set / Unset failover DID --------------------- //
//$props['failover_did'] = 9876543210;
//$props['failover_num'] = 10; // Offline calls number
//$props['failover_time'] = 60;   // Offline time possible values: 3, 5, 7, 10, 15, 20, 30, 60


//$result = $api->setDidFailover(9143520741, $props); // Set failover
//$result = $api->setDidFailover(9143520741); // Unset failover


// --------------  Voice DID forwaring ------------------------- //
//$result = $api->forwardDID(5876006899); // Set Forwarding
//$result =  $api->forwardDID(9192138311); // Unset Forwarding
//print_r($result);


// --------------  Set / Unset Port Out  Validation (Protection) ------------------------- //
//$result = $api->setpinDID(9192138311, 1234); // Set PIN
//$result = $api->setpinDID(9192138311);  // Unset PIN


// -------------- Route / Unroute DID to(from) SIP account --------------------- //
//$result = $api->routeDID( 9192138311, 'helloWorld3'); 
//$result = $api->routeDID("9192384912");


// -------------- Order CNAM --------------------- //
//$result = $api->orderCnam(1234567890); 


// -------------- Remove CNAM --------------------- //
//$result = $api->removeCnam(1234567890); 


// -------------- Order E911  --------------------- //
/*
$params = array(
    'did'        => 1234567890,     // DID to order e911 service
    'name'       => 'John Doe',     // Customer name (first and last)
    'address'    => '2040 Larimer', // Address
    'unit_type'  => 'apt',          // Unit type, Optional. Allowed values (one of): unit, suite, apt
    'unitnumber' => 33,             // Unit number. Optional. Works if Unit type is set
    'city'       => 'Denver',       // City
    'state'      => 'CO',           // State (2 chars)
    'zip'        => '80205'         // ZIP code
);
$result = $api->orderE911($params); 
*/

// -------------- Remove E911 --------------------- //
 //$result = $api->removeE911(1234567890); 


// -------------- Remove Local or Toll Free DID --------------------- //
//$result = $api->removeDID(8888888888); 



/*
 * Managing International DIDs
 */

// -------------- Country list in which the available DID --------------------- //
//$result = $api->listInternationalCountry();

 
// -------------- City available list of cities for selected country --------------------- //
//$result = $api->listInternationalCity('GB');
 

// -------------- Order international DID --------------------- //
//$result = $api->orderInternationalDid('GB', 'LONDON');
 
 
// -------------- List ordered international DID --------------------- //
//$result = $api->listInternationalDids();


// -------------- Set / Remove international DID  forwarding  --------------------- //
//$result = $api->setInternationalDidForward(234567890, 9876543212); 


// -------------- Delete international DID --------------------- //
//$result = $api->removeInternationalDid(234567890);


// -------------- Country list international --------------------- //
//$result = $api->internationalRateCountryList();


// -------------- Operators rate for seleted country--------------------- //
//$result = $api->internationalRates(2689);


// -------------- Operators rate for countries dialed without 011 (Codes: 1204, 1226, 1236 etc)--------------------- //
//$result = $api->internationalRates2();


/*
 * LNP - Local Number Portability
 */

// -------------- Check Port Availability  --------------------- //
//$result = $api->checkPortLnp( array(3073521125, 3073521126) );
//$result = $api->checkPortLnp( 9143520733);       

// -------------- Send LNP Request --------------------- //     
/*
$params = array(
         'port_number'          => '3073521126',    
         'foc_date'             => '2019-01-18',   // Request Firm Order Commitment (FOC) date. Optional
         'activate_time'        => '16:00',   // Reuested FOC Activation time Eastern Standard Time (EST). Optional, from 00:00 to 23:00 Must be roud hour if set (12.00, 13.00 etc)
         'did_mode'             => 1,                   // 0 - Voice, 1 - Faxing
         'route_to'             => 'trunk1',       // String. Optional. SIP trunk name to route the DID to. For voice DIDs only.
         'partial_port'         => 0,                   // 0 - No, 1 - Yes. Required
         'extra_services'       => '',                  // String. Required if only partial_port == 1
         'location'             => 'Business',          // Values: Business, Residential. Required
         'company'              => 'My Company Name',   // Company name. Required if location is set to Business
         'wireless_no'          => 1,                   // 0 - No, 1 - Yes. Required
      	 'pincode'              => '4444',              // Wireless account PIN code. Required if  wireless_no == 1 only
       	 'ssn'                  => '5555',              // SSN last four digits. Required if  wireless_no == 1 only
         'lidb_list'            => 0,                   // Values:   0 - No, 1 - Yes. Required
         'provider_name'        => 'AT&T',              // Max. 255 chars. Required
         'account_no'           => '111',              // Max. 100 chars. Required
         'authorize_contact'    => 'John Doe',          // Max. 15 chars. Required
         'contact_title'        => 'CEO/Owner',         // Values: Employee, President, CEO/Owner.  Required
         'street_no'            => '17342',             // Max. 50 chars. Required
         'dir_prefix'           => 'None',              // Max. 10 chars. Values example: None, N, NE, E, SE, S, SW, W, NW. Optional
         'street_name'          => 'Park Avenue',       // Max. 100 chars. Required
         'dir_suffix'           => 'NE',                // Max. 10 chars. Values example: None, N, NE, E, SE, S, SW, W, NW. Optional
         'service_unit'         => '87',                // Service Suit/Unit. Max. 100 chars. Optional
         'city'                 => 'Houston',           // Service City. Max. 100 chars. Required
         'states'               => 'MA',                // Service State. Optional
         'zipcode'              => '55346',             // Service ZipCode Max. 20 chars. Required
         'billing_telephone_no' => '3042051420',        // Billing Telephone Number. Max. 20 chars.  Required
);

$files = array(
    'bill_file'            => '/path/to/bill/file.jpg'        // Phone bill, full path to GIF, JPG, PNG or PDF file. Size up to 2Mb
);

$result = $api->orderLnp($params, $files); 
*/

// -------------- List  active LNP requests --------------------- //
//$result = $api->listLnp();


// -------------- Status LNP request --------------------- //
 //$result = $api->statusLnp(7193675002); 


// -------------- Remove LNP request --------------------- //
// Statuses to allow remove LNP: submitted, awaiting signature, awaiting documentation, pending approval, processing
//$result = $api->deleteLnp(6623048653); 





/*
 * Fax
 */

// -------------- List states  (to get Fax Rate centers) --------------------- //
//$result = $api->faxListStates();


// -------------- Get Fax Rate Centers list (by State) --------------------- //
//$result = $api->faxListRatecenters('DE'); 



// -------------- Get Fax DIDs List --------------------- //
//$result = $api->faxListAvailableDids('Angola', 'DE');  // Local Fax DIDs - by Ratecenter and State
//$result = $api->faxListAvailableDids();  // Toll Free DIDs list


// -------------- Order and Assign new DID to Fax account(Local or Toll free ) --------------------- //
//$result = $api->faxOrderDid(3025490958, 'my fax note');  

// -------------- List Fax DIDs assigned to the account --------------------- //
//$result = $api->faxListDids();  

// -------------- Set add/remove Fax DID Note --------------------- //
//$result = $api->setFaxDidNote(9199071744,  'Fax wdfsdf');

// -------------- Set iFax Port Out Validation PIN--------------------- //
//$result = $api->setFaxDidPin(9199071744, 1342);


// -------------- Remove Fax DID --------------------- //
//$result = $api->faxRemoveDid(1234567999);  


// -------------- Create new Fax user --------------------- //
//$result = $api->faxCreateUser('John Doe', 'white@house.com', 'myLogin', 'myPassword', 5876006982);
//$result = $api->faxCreateUser('John', '', '5876006982', 'myPassword', 5876006982);

// -------------- Update Fax password --------------------- //
//$result = $api->faxUpdatePassword(5876006982, 'myPassword');

// -------------- Delete  Fax user--------------------- //
//$result = $api->faxDeleteUser(5876006982);



// -------------- Set Email to Fax Authorized Email and Email to forward inbound Fax --------------------- //
// 
// -------------- Add new Email authorized to send/ receive faxes ------------ //
//$result = $api->faxEmailAdd(5876006982, '77@77.com',  1, 1);

// -------------- LIst Emails authorized to send/ receive faxes ------------ //
//$result = $api->faxEmailsList(5876006982 );

// -------------- Updatw settings of Email authorized to send/ receive faxes  ------------ //
//$result = $api->faxEmailEdit(5876006982, '77@77.com', 1,0);

// -------------- Rrmove  authorized Email ------------ //
 //$result = $api->faxEmailDelete(5876006982, '77@77.com');
 
 
// -----Depreciated method!!!  
// It's highly recommended to use faxEmailAdd(), faxEmailsList(), faxEmailEdit(), faxEmailDelete() instead.  
//$result = $api->faxAuthfaxEm(9199071744, 'auth1@email.com, auth2@email.com', 'forward1@email.com, forward2@email.com'); // Set Authorized and forwarding Email
//$result = $api->faxAuthEmail(9199071744, '',  'forward1@email.com, forward2@email.com'); // Unset Authorized Email
//$result = $api->faxAuthEmail(9199071744); // Unset Forwarding Email


// 1234567890 - source Fax number
// 9876543210 - destination Fax number
//$result = $api->faxSend(1234567890, 9876543210, 'John Doe', '/path/to/file/file.pdf');
 

// -------------- iFax history (in/out) --------------------- //
//     @param (string) $did - Your fax to see fax history, all numbers by default   
//$result = $api->faxHistory('all', 0, 0, 601269);
// $result = $api->faxHistory(5876006982, 1 );
 //$result = $api->faxHistory( 'all', array("2019-01-15 00:00:01", "2019-01-17 23:59:59") );
 
 
// $result = $api->faxHistory('all', array('2017-01-25 13:00:00', '2017-01-25 14:00:00'), 1 );
    

// -------------- Get Fax file base64 encoded by fax ID --------------------- //
//$result = $api->faxDownload(634379);




// --------------------------- iFax Enterprise --------------------- //
//faxListStates(), faxListRatecenters('NE'), faxListAvailableDids()  // The same as iFax regular

//-------------- Order and Assign new DID to Fax account(Local or Toll free ) 
//$result = $api->fax2OrderDid(9999988888, 'my fax note2', 23);     

// -------------- List Fax DIDs assigned to the account --------------------- //
//$result = $api->fax2ListDids(23);  

// -------------- Set add/remove Fax DID Note --------------------- //
//$result = $api->fax2SetDidNote(5876006955 ,  'my note1');

// -------------- Set iFax Port Out Validation PIN--------------------- //
//$result = $api->fax2SetDidPin(1234567892);

// -------------- iFax Pending / Activate DID--------------------- //
//$result = $api->fax2SetDidPending(9999999999, 'active');  // pending, active

// -------------- Remove Fax DID --------------------- //
//$result = $api->fax2RemoveDid(1234567891);  



// ---iFax Enterprise Groups 
//$result = $api->fax2GroupCreate('s_name', 'l_name');

//$result = $api->fax2GroupsList();
//$result = $api->fax2GroupsList();
//$result = $api->fax2GroupsList(array(17,17));

//$result = $api->fax2GroupEdit(14, 's_name14', 'l_name14');
//$result = $api->fax2GroupDelete(14);

       
// --- iFax Enterprise Users
//$result = $api->fax2UserCreate(17, 'u17', 'u17', 1, 'John', 'Doe', 'some@mail.com');
//$result = $api->fax2UsersList(17);
//$result = $api->fax2UserEdit(27, 'test33', 0,  'John', 'Die',  '55@222.com');  
//$result = $api->fax2UserUpdatePasswd(27, 'hellopassword');  
//$result = $api->fax2UserDelete(34);


// --- iFax Enterprise Config
//$result = $api->fax2ConfigCreate(27, 8334441390, 1, 1, 0,0);
//$result = $api->fax2ConfigList(8334441390);
//$result = $api->fax2ConfigEdit(36, 0, 0, 0, 1);
//$result = $api->fax2ConfigDelete(36);

// --- iFax Enterprise Email
//$result = $api->fax2EmailAdd(8334441390, '88@88.com',  1, 1);

//$result = $api->fax2EmailsList(23, 5876006955);
//$result = $api->fax2EmailsEdit(28, '88@88.com'', 0,1);
// $result = $api->fax2EmailsDelete(28);


// -------------- iFax Enterprise send fax --------------------- //

//$result = $api->fax2Upload( '/path/to/file/fax.txt');

// 1234567890 - source Fax number
// 9876543210 - destination Fax number
//$result = $api->fax2Send(8334441390, 5876006955, array('e14d651d-30b6-4c04-aaa0-1d719c91a262')  );

 
//  
// -------------- iFax Enterprise history (in/out) --------------------- //
//     @param (string) $did - Your fax to see fax history, all numbers by default   
//$result = $api->fax2History('all', 0, 0);
// $result = $api->fax2History(8334441390, 0, 0, 601283 );
// $result = $api->fax2History( array(1234567890, 1234567891), array('2017-01-25 21:00:00', '2017-01-30 22:00:00') );
// $result = $api->fax2History('all', array('2017-01-25 13:00:00', '2017-01-25 14:00:00'), 1, 'ifax' );
    

// -------------- Get Fax file base64 encoded by fax ID --------------------- //
//$result = $api->fax2Download(601283);


/*
 * SMS
 */

// -------------- Enable / Disable DID for SMS service--------------------- //
// Available for tier 1 and 1b only!
//$result = $api->smsManageDid(5876006899, 'enable'); //Values: enable, disable 
//$result = $api->smsManageDid(5876006899, 'disable');


// -------------- Add / Remove Email for SMS forwarding--------------------- //
                                                                     // none, email, xmpp, both, url 
//$result = $api->smsManageEmailForward(9143520733, 'white@house.gov', 'email'); // Forrward SMS to Email
//$result = $api->smsManageEmailForward(9143520733, '', 'xmpp', 'myXMPPname', 'myXMPPpasswd'); // Send to XMPP
// $result = $api->smsManageEmailForward(9143520733, '', 'url', '', '', 'http://someSite.com'); // Post SMS to URL
//$result = $api->smsManageEmailForward(9143520733); // Disable SMS


// -------------- Send SMS Mmessage--------------------- //
//$result = $api->smsSend(9194393755, 5876006899, 'my API SMS mesage', '/path/to/file.jpg');  
//$result = $api->smsSend(9194393755, 5876006899, 'my SMS message');

 
/*
 * Virtual and dedicated servers
 */

// -------------- Order Virtual or dedicated server--------------------- //
//$result = $api->serverAdd('dedicated', 'My note here'); //Values: dedicated

// -------------- Ordered Virtual or dedicated servers property--------------------- //
//$result = $api->serverList('all', 'active'); //Values: dedicated, virtual, all. Type values: active, pending, all

// -------------- Remove Dedicated or Virtual server ------------------------------- //
//$result = $api->serverRemove(233);

// -------------- Add new IP address to the list allowed to login (SSH) IPs  --------------------- //
//$result = $api->serverIpAdd(322, '125.125.125.124');

//  ------------- List of IP allowed to access the server via SSH--------------------- //
//$result = $api->serverIpList(322); 

// -------------- Remove IP address from list allowed IP to login (SSH) --------------------- //
//$result = $api->serverIpRemove(322,  '124.124.124.124');



/*
 * QuBe virtual or Dedicated servers
 */

// -------------- Order Virtual or dedicated QuBe server--------------------- //
//$result = $api->serverQubeAdd('dedicated', 'My server note'); //virtual, dedicated

// -------------- Ordered Virtual or dedicated QuBe servers property--------------------- //
//$result = $api->serverQubeList('all', 'all'); //dedicated, virtual, all  //active, pending, all

// -------------- Remove QuBe Dedicated or Virtual server ------------------------------- //
//$result = $api->serverQubeRemove(654);

// -------------- Add new IP address to the list allowed to login (SSH) IPs  --------------------- //
//$result = $api->serverQubeIpAdd(701, '125.125.125.125', 'my note here');

//  ------------- List of IP allowed to access the QuBe server via SSH--------------------- //
//$result = $api->serverQubeIpList(701); 

// -------------- Remove IP address from list of allowed to login (SSH) IP --------------------- //
//$result = $api->serverQubeIpRemove(701,  '125.125.125.124');






/*
 * Account methods
 */

// -------------- Get account balance and autorefill config--------------------- //
//$result = $api->accountGetBalance();

    
// -------------- Allow / Forbid autorefill--------------------- //
//$result = $api->accountSetRefill('enable');  // enable / disable


// --------------Set Refill settings - min value, refill anmount--------------------- //
// Minimal balance available values: 5, 25, 30, 35, 40, 45, 50
// Autoefill amount available values:  25, 50, 60, 70, 80, 90, 100, 200, 300, 400, 500
//$result = $api->accountRefillConfig(5, 500);

    
// -------------- Refill balance--------------------- //
//$result = $api->accountRefill(10); // $10 - minimal amount 


// -------------- Retrieve your rates --------------------- //
// $result = $api->accountRates(); 


/*
 * Support tickets
 */

// -------------- List Last 20  Tickets--------------------- //
//$result = $api->supportLastTicketsList();


// -------------- View Support Ticket--------------------- //
//$result = $api->supportReadTicket(2015618);


// -------------- Create Support Ticket (Post)--------------------- //

//$files = array('/full/path/to/file_to_send.pdf');      
                             // $msg, $subj, $ticket_id, $close_ticket, $files
//$result = $api->supportCreatePost('My message', 'ticket Subject', 0, 'no', $files); // Create new ticket 
//$result = $api->supportCreatePost('My message', '',  2027266, null); // Post message to existing ticket



echo '<pre>';
print_r($result);
?>
</body>    
</html>