<?php
/*
QuestBlue.com Customers API toVoIP services  has been added
Copyright (c)2014 QuestBlue Systems, Inc

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
  
* @author   QuestBlue Systems, Inc at <software-engineering@questblue.com>
* @version  $id: qbapi.class.php, v 2.3.3  January 17, 2019  
* @access   public
* 
 * May the Force be with you!
* 
* Release History
* 2019/06/12, v 2.3.5 - Post SMS to URL has been added
* 2019/02/27, v 2.3.4 - DID search by ZIP code (see listAvailableLocalDIDs method) been added
* 2019/01/17, v 2.3.3 - FOC date request completion date been added
* 2018/12/17, v 2.3.2 - iFax.Pro Email manager  been updated
* 2018/10/13, v 2.3.0 - New SMS amd MMS sending been added
* 2018/09/19, v 2.2.4 - Manage SIP Trunk Inbound Call Forwarding 
* 2018/09/17, v 2.2.3 - Call History Summary
* 2018/09/14, v 2.2.2 - iFax Enterprose has added
* 2018/07/20, v 2.2.1 - iFax Port Out Validation has added
* 2018/07/17, v 2.2.0 - Add callack to createSipTrunk, add error warning
* 2018/07/13, v 2.1.9 - Updating SIP trunks properties, list active LNP requests 
* 2018/07/12, v 2.1.8 - Get sent FAx statu sby it ID has added
* 2018/07/11, v 2.1.7 - Selecting Toll Free coe has added to the listAvailableTfDIDs method
* 2018/06/27, v 2.1.6 - Port Out Validation using secure PIN has added 
* 2018/06/6,  v 2.1.5 - Filter to retrieve CDR for specific DIDs  has added  
* 2018/02/7,  v 2.1.4 - Voice DID note and Fax DID note added  
* 2018/01/10, v 2.1.3 - iFax variables Email authorizated to send faxes and Emaikl to forward inbound faxes are splitted
* 2017/11/30, v 2.1.2 - Fax -> iFax migration completed
* 2017/11/30, v 2.1.1 - Fax -> iFax migration initialized
* 2017/07/14, v 2.0.2 - QuBe Server manipulation has added
* 2017/05/28, v 2.0.1 - Set call forwarding on exceeding failover calls munber
* 2017/03/02, v 2.0.0 - LNP request removal
* 2017/02/02, v 1.9.5 - Multiple  DID tiers  has added
* 2016/12/07, v 1.9.4 - Access customet rates has added
* 2016/11/22, v 1.9.3 - Failover IP address has added
* 2016/10/28, v 1.9.2 - Show visitor interface IP address
* 2016/10/15, v 1.9.1 - International rates(2) has added
* 2016/08/09, v 1.9.0 - Routing voice DID to SIP trunk on sending LNP request has added
* 2016/07/01, v 1.8.9 - Opion to send E911 Unit type and Unit number has added
* 2016/06/17, v 1.8.8 - Managing IP addresses to access via SSH has added
* 2015/12/22, v 1.8.7 - Email-to-Fax serive->setup trusted Email has added
* 2015/10/23, v 1.8.6 - Fax history and fax download has added
* 2015/06/29, v 1.8.5 - Minor bugs fixing
* 2015/05/21, v 1.8.4 - Lock / Unlock SIP Trunk has added 
* 2015/04/21, v 1.8.3 - Check Port Number for an LNP availability 
* 2015/01/29, v 1.8.2 - Account Balance View, Refill Balance Settings, Refill Balance, Make Payment, 
*                       Support Tickets - Li stTickets List, Reat Ticket, Create Ticket
* 2015/01/19, v 1.8.1 - International call rate were added
* 2015/01/15, v 1.8  - International DIDs ordering were added.
* 2014/11/27, v 1.7  - Option to update SIP account's IP address was added.
* 2014/07/21, v 1.6  - Server (virtual and dedicated) managing were added.
* 2014/05/19, v 1.5  - SMS options (send, receive were added.
* 2014/05/08, v 1.4  - Fax options (send, receive, listings) were added. Minor bugs fixed.
*                     //--- Signature file Sending  is not required anymore on LNP request  --- //
* 2014/03/13, v 1.3  - LNP request status was added
* 2014/03/06, v 1.2  - Route/ Unroute Multile additional IP address to the SIP  trunk
* 2014/03/02, v 1.1  - route / unroute additional IP address to the SIP  trunk
* 2014/01/10, v 1.0  - Released
*/


class QBapi {
    
    /*
     * Test connection to API to make sure that login, API key etc work fine 
     */
    public function testApiConnect() 
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    
    
    /*
     * Show your interface IP address
     */
    public function myIP() 
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    
    
   /*
    * Retrieve US states list
    * @return Object
    */
    public function listStates()
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    

    /*
     * Get Rate Centers list
     * 
     * @param (string) - state. Length - 2 chars  (MA, TX)
     * @param (int) $tier - DID tier. Values: 1(default) or 2.  1 - SMS support enabled,  2- SMS support disabled
     * @return Object
     */
    public function listRateCenters($state = null, $tier = 1)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<state>' . htmlspecialchars($state) . '</state>'; 
        $request .= '<tier>' . $tier . '</tier>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }
    
    
    /*
     * Local DIDs list
     * 
     * You should use $ratecenter/$state or $npa to get DIDs list
     * @param (string) $ratecenter - rate center name (ADAMS)
     * @param (string) $state - US state two chars (MA)
     * @param (digit) $npa - US Area Code, 3 symbol. See details at: http://en.wikipedia.org/wiki/List_of_North_American_Numbering_Plan_area_codes
     * @param (int) $tier - DID tier. Values: 1(default), 1b 
     */
    public function listAvailableLocalDIDs($ratecenter = null, $state = null, $npa = null, $tier = 1)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<ratecenter>' . htmlspecialchars($ratecenter) . '</ratecenter>'; 
        $request .= '<state>' . htmlspecialchars($state) . '</state>'; 
        $request .= '<npa>' . htmlspecialchars($npa) . '</npa>'; 
        $request .= '<tier>' . $tier . '</tier>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
    
    /*
     * Toll Free DIDs list
     * 
     * @param (string) $tier - DID tier. Values: 1b - DID with SMS support,  1- without SMS support
     * @param (int) $code - Toll Free code, two chars. Examples: 80, 84, 85, 86. Optional.
     */
    public function listAvailableTfDIDs($tier = 1, $code = '') 
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<tier>' . $tier . '</tier>'; 
        $request .= '<code>' . $code . '</code>'; 
        $request .= '</params>';

        return $this->sendRequest($request);  
    }
    

    /*
     * Order Local or Toll Free DID
     * 
     * @param (int) $did - DID to order
     * @param (int) $tier - DID tier. Values 1 - DId with SMSsupport, 2 - DID without SMS support
     * @param (string) $note - DID NOte. Optional, up 12 chars
     */
    public function orderDID($did, $tier = 1, $note='')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '<tier>' . htmlspecialchars($tier) . '</tier>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    

    /*
     * Add or remove note(comment) to specific DID
     */
    public function setDidNote($did, $note='')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    
    /*
     * Get DID(s) propery
     * 
     * @param (mixed) - all: show all ordered DID's property, DID number (string or array): property for eneterd DID only
     * @return XML Object
     */
    public function propertyDid($did = 'all')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        if($did != 'all')
        {
            $request .= '<params>';
            if(is_array($did))
            {
                foreach($did as $v) {
                    $request .= '<did>' . htmlspecialchars($v) . '</did>'; 
                }
            } else {
                $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
            }
            $request .= '</params>';
        }
        
        return $this->sendRequest($request);
    }
    
    
    /*
     * Set / Unset failover DID.
     * 
     * @param (int) $did - DID to set/unset failover calls to. 
     * @param (int) $props - Array OR NULL. Unset to remove filover
     * @param $props['failover_did'] - US based number to set failover. Value: Ten digit only
     * @param $props['failover_num'] - Offline inbound calls number within defined (failover_time) time range.
     *        Ten digit number is required
     * @param $props['failover_time'] - Offline time interval (minutes)
              Possible values: 2, 3, 5, 7, 10, 15, 20, 30, 60
     */
    public function setDidFailover($did, $props = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        if(is_array($props))
        {
            foreach($props as $k => $v) {
                $request .= '<' . $k . '>' . htmlspecialchars($v) . '</' . $k . '>'; 
            }
        } 
        $request .= '</params>';
        return $this->sendRequest($request);
    }
    public function setDidFaiover($did, $props = null) {
        return $this->setDidFaiLover($did, $props);
    }
    
    /*
     * Add / Remove DID forwarding
     * 
     * @param $did (int) - DID to forward incoming calls
     * @param $did_forward (mixed). US nases (10 dogits) DID to forward 
     * @return XML Object
     */
    public function forwardDID($did, $did_forward = 'none')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<did_forward>' . $did_forward . '</did_forward>'; 
        $request .= '</params>';

        return $this->sendRequest($request);
    }

    
    /*
     * Add / Remove Port Out Validation PIN
     * 
     * @param $did (int) - DID to set/unset PIN (must be active)
     * @param $pin (int) - Four digit PIN or empty to unset
     * @return XML Object
     */
    public function setpinDID($did, $pin = 'none')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<pin>' . $pin . '</pin>'; 
        $request .= '</params>';

        return $this->sendRequest($request);
    }
    
    
    /*
     * Remove Local or Toll Free DID
     * 
     * @param (int) $did - DID to delete
     * @return XML Object
     */
    public function removeDID($did)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Set CallerID for a DID
     * 
     * @param (int) $did - did to set Caller ID
     * @param (string) $name - Caller ID to assign. Up to 15 chars, alphanumeric
     */
    public function setLidb($did = '', $name = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '<name>' . htmlspecialchars($name) . '</name>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }  
    
    
    /*
     * Route DID to SIP accounts
     * 
     * @param (int) $did - DID to route
     * @param (string | empty) $trunk - trunk to route to. If empty DID is goung to be unrouted
     * @return XML Object
     */
    public function routeDID($did, $trunk = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Order CNAM
     * 
     * @param (int) $did - DID to order CNAM service
     * @return XML Object
     */
    public function orderCnam($did)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Order CNAM
     * 
     * @param (int) $did - DID to remove CNAM service
     * @return XML Object
     */
    public function removeCnam($did)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request);  
    }
    
    
    /*
     * Order E911
     * 
     * @param (array) $params - customer personal data
     *      did - DID to order e911 service
     *      name - customer name (first and last)
     *      address - customer address
     *      unit_type. Possible values: unit(Unit), suite(Suit), apt(Apartment)
     *      unitnumber - Number of unit (suit, apartment)
     *      city - City
     *      state - State
     *      zip - ZIP code

     * @return XML Object
     */
    public function orderE911($params)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        
        foreach($params as $k => $v) {
            $request .= '<' . $k . '>' . htmlspecialchars($v). '</' . $k . '>';   
        }
        $request .= '</params>';
  
        return $this->sendRequest($request);  
    }
    
    
    /*
     * Remove E911
     * 
     * @param (int) $did - DID to remove e911 service
     * @return XML Object
     */
    public function removeE911($did)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
   
    
    // International DIDs
    
    /*
     * Countries list available international DIDs
     * 
     * @param (string) - state. Length - 2 chars  (MA, TX)
     * @return Object
     */
    public function listInternationalCountry()
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    
    
    /*
     * List available city
     * 
     * @param (string) $country_code - Available cities list to order DID.  Length - 2 chars  (MA, TX)
     * @return Object
     */
    public function listInternationalCity($country_code)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<code>' . htmlspecialchars($country_code) . '</code>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }

    
    /*
     * Order International DID
     * 
     * @param (string) $country_code - country code, 2 chars.
     * @param (string) $city - city to order DID
     * @param (int) $did_redirect - local DID to redirect calls 
     */
    public function orderInternationalDid($country_code, $city, $did_redirect = 0)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<code>' . htmlspecialchars($country_code) . '</code>'; 
        $request .= '<city>' . htmlspecialchars($city) . '</city>'; 
        $request .= '<did_redirect>' . $did_redirect . '</did_redirect>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * List ordered international DIDs
     */
    public function listInternationalDids() {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    

    /*
     * Set/Remove international DID forwarding
     */
    public function setInternationalDidForward($did, $did_redirect = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<did_redirect>' . $did_redirect . '</did_redirect>'; 
        $request .= '</params>';
        return $this->sendRequest($request); 
    }
        
    
    /*
     * Delete international DID
     */
    public function removeInternationalDid($did = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '</params>';
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Get country list call rate is availaable
     */
    public function internationalRateCountryList()
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    
    
    /*
     * Get phone operators rates for seleted coumtry
     */
    public function internationalRates($country_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<country_id>' . $country_id . '</country_id>'; 
        $request .= '</params>';
        return $this->sendRequest($request); 
    }
    
   
    /*
     * International rates for non 011 countries
     */
    public function internationalRates2()
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }

    
    /*
     * Create SIP trunk
     * 
     * @param (string) $trunk - alpha-numeric
     * @param (string) $ip_address - address to bind SIP account to
     * @param (string) $passwd - Trunk password. For registration only!
     * @param (array | null) $callback - method to run on callback and it arguments 
            Example:  createSipTrunk('myTrunkName', '9.9.9.9', '', array('routeDID', 'did' => '8552010059', 'trunk'=> 'myTrunkName')  );
     * @return XML Object
     */
    public function createSipTrunk($trunk, $ip_address = '', $passwd = '',  $callback = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '<ip_address>' . htmlspecialchars($ip_address) . '</ip_address>';
        $request .= '<passwd>' . htmlspecialchars($passwd) . '</passwd>';
        if(is_array($callback)) 
        {
            $request .= '<callback>'; 
            foreach($callback as $k => $v)
            {
               if($k === 0) {
                  $request .= '<method>' . $v . '</method>'; 
               } else {
                  $request .= '<'.$k.'>' . $v .'</'.$k.'>'; 
               }
            }
            $request .= '</callback>';
        }
        
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
    
    /*
     * SIP trunk(s) property
     * 
     * @param (mixed) $trunk - SIP trunk name. empty - all trunks, string or array - entered values
     * @return XML Object
     */
    public function listSipTrunks($trunk = 'all')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        if($trunk != 'all')
        {
            $request .= '<params>';
            if(is_array($trunk))
            {
                foreach($trunk as $v) {
                    $request .= '<trunk>' . htmlspecialchars($v) . '</trunk>'; 
                }
            } else {
                $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
            }
            $request .= '</params>';
        }
        return $this->sendRequest($request);
    }
    
 
    /*
     * Assign new IP addres sto SIP account
     * 
     * @param (string) $trunk - alpha-numeric, required
     * @param (string) $ip_address - address to bind (replace) SIP account with
     * @return XML Object
     */
    public function updateSipIp($trunk, $ip_address)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '<ip_address>' . htmlspecialchars($ip_address) . '</ip_address>';
        $request .= '</params>';
    
        return $this->sendRequest($request);
    }
    
    
    /*
     * Set failover IP on exceeding X offline calls within Y minutes  
     */
    public function sipFailoverIp($trunk, $action = 'disable', $props=array() )
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '<action>' . $action . '</action>'; 
        if(count($props) == 3) 
        {
            $request .= '<failover_ip_address>' . $props[0] . '</failover_ip_address>'; 
            $request .= '<failover_offline_call_num>' . $props[1] . '</failover_offline_call_num>'; 
            $request .= '<failover_offline_time>' . $props[2] . '</failover_offline_time>'; 
        }
        $request .= '</params>';
    
        return $this->sendRequest($request);
    }
    

    
    /*
     * Enable / Sidable international calls
     * 
     * @param (string) $trunk - SIP trunk name
     * @param (string) $action - Action to do. Values: on / off - turn ON / tirn OFF international calls
     */
    public function sipSetInterCalls($trunk, $action = 'off')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '<action>' . htmlspecialchars($action) . '</action>'; 
        $request .= '</params>';
        return $this->sendRequest($request);
    }
    
    
    /*
     * Enable / Didable dynamic DNS
     * 
     * @param (string) $trunk - SIP trunk name
     * @param (string) $host - Dynamic Host name to check 
     */
    public function sipSetDdns($trunk, $host = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '<host>' . htmlspecialchars($host) . '</host>'; 
        $request .= '</params>';
        return $this->sendRequest($request);
    }
    
    
    /*
     * Set entire trunk call forwarding
     * 
     * @param (string) $trunk - Trunk to manage forwarding
     * @param (string) $did - US based DID to forward all inbound calls
     */
    public function sipSetForward($trunk, $did = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '<did>' . $did . '</did>'; 
        $request .= '</params>';
        return $this->sendRequest($request);
    }  

    
    /*
     * Lock SIP trunk
     * @param (string) $trank - trunk name
     * @return XML Object
     */
    public function lockSipTrunk($trunk)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
      
    /*
     * UnLock SIP trunk
     * 
     * @param (string) $trank - trunk name
     * @return XML Object
     */
    public function unlockSipTrunk($trunk)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
    
    /*
     * Delete SIP trunk
     * 
     * @param (string) $trank - trunk name
     * @return XML Object
     */
    public function deleteSipTrunk($trunk)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
    
    /*
    View Call History
    @param (string | array) $trunk - Trunk(s) to see calls history, all trunks by default
    @param (int | array) $period - Date range. 
        Values: (int) 0 (default) - current hour, 
                (int) 1 - previous hour,  
                (int) 2 - today, 
                (int) 3- yesterday, 
                (array) start time / end time. Example: array('2015-06-21 21:00:00', '2015-06-26 22:00:00')       
    @param (int) $type - Type of calls. 
         Values: (int) 0 (default) - All calls, 
                 (int) 1 - incoming calls, 
                 (int)2 - Outgoing calls
    @param (string) $show_empty - Whether to show unsuccessful CDRs in a query result. 
        no - do not show unsuccessful calls. By default
        yes - show all calls
    @param (string | array) $did - DID(s) to pull call history
    @param (string) $summary_only - dasplay call summary only
     * 
    @return XML Object
     */
    
  
    public function callHistory($trunk = 'all', $period = 0, $type = 0, $show_empty = 'no', $did = 'all', $summary_only = 'no', $min_id = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>'; 
        
        if(is_array($trunk))
        {
            foreach($trunk as $v) {
                $request .= '<trunk>' . htmlspecialchars($v) . '</trunk>'; 
            }
        } else {
            $request .= '<trunk>' . htmlspecialchars($trunk) . '</trunk>'; 
        }
        
        if(is_array($did))
        {
            foreach($did as $v) {
                $request .= '<did>' . $v . '</did>'; 
            }
        } else {
            $request .= '<did>' . $did. '</did>'; 
        }
        
        if(is_array($period))
        {
            foreach($period as $v) {
                $request .= '<period>' . $v . '</period>'; 
            }
        } else {
            $request .= '<period>' . $period . '</period>'; 
        }
            
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<show_empty>' . $show_empty . '</show_empty>'; 
        $request .= '<summary_only>' . $summary_only . '</summary_only>'; 
        $request .= '<min_id>' . $min_id . '</min_id>'; 
        
        
        
        $request .= '</params>';
        
       // echo '<pre>';  print_r($request);  die;
        
        
        return $this->sendRequest($request);
    }
    

    /*
     * Check Port Number LNP availability
     * 
     * @param (string) $port - port number to check
     * @return XML Object
     */
    public function checkPortLnp($port)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        if(is_array($port)) 
        {
            foreach($port as $p) {
                $request .= '<port_number>' . $p . '</port_number>'; 
            }
        } else {
           $request .= '<port_number>' . $port . '</port_number>';  
        }
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
    
    /*
     * LNP request 
     * 
     * @param (array) $params - request  data
         *      port_number - Max. 100 chars.  Required
         *      foc_date - Request Firm Order Commitment (FOC) date. Optional. Example: 2019-01-27
         *      activate_time - Reuested FOC Activation time Eastern Standard Time (EST). Optional, from 00:00 to 23:00 Must be roud hour if set (12.00, 13.00 etc)
         *      did_mode - Digit 1 char. Values: 0 - Voice, 1 - Faxing
         *      partial_port - Max 1 char. Values:   0 - No, 1 - Yes. Required
         *      extra_services - Optional
         *      location - Values: Business, Residential. Required
         *      wireless_no -  Values:   0 - No, 1 - Yes. Required
         *      lidb_list - Values:   0 - No, 1 - Yes. Required
         *      provider_name - Required
         *      account_no - Max. 100 chars. Required
         *      authorize_contact - Max. 100 chars. Required
         *      contact_title - Values: Employee, President, CEO/Owner.  Required
         *      street_no - Max. 50 chars. Required
         *      dir_prefix - Max. 10 chars. Values: None, N, NE, E, SE, S, SW, W, NW. Optional
         *      street_name - Max. 100 chars. Required
         *      dir_suffix - Max. 10 chars. Values: None, N, NE, E, SE, S, SW, W, NW. Optional
         *      service_unit - Max. 100 chars. Required
         *      city - Max. 100 chars. 
         *      states -  Values: AB, AL, AR, AZ, BC, CA, CO, CT, DC, DE, FL, GA, HI,
                                             IA, ID, IL, IN, KS, KY, LA, MA, MB, MD, ME, MI, MN,
                                             MO, MS, MT, NC, ND, NE, NF, NH, NJ, NM, NV, NY, OH,
                                             OK, ON, OR, PA, PQ, PR, QB, RI, SC, SD, SK, TN, TX,
                                             UT, VA, VT, WA, WI, WV, WY. Optional
         *      zipcode - Max. 20 chars. Required
         *      billing_telephone_no -  Max. 20 chars.  Required
     * @return XML Object
     */
    public function orderLnp($params, $files)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        
        foreach($params as $k => $v) {
            $request .= '<' . $k . '>' . htmlspecialchars($v). '</' . $k . '>';   
        }
        foreach($files as $k => $v)
        {
            if(is_file($v)) {
                $request .= '<' . $k . '>' . base64_encode( file_get_contents($v)). '</' . $k . '>'; 
            } 
        }
        $request .= '</params>';
        
        return $this->sendRequest($request);  
    }
    
    
    /*
     * List active LNP requests
     */
    public function listLnp()
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        return $this->sendRequest($request);  
    }
    
    
    /*
     * Get LNP request status
     * 
     * @param (int) $port_number - the Port number
     * @return XML Object
     */
    public function statusLnp($port_number)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<port_number>' . htmlspecialchars($port_number) . '</port_number>'; 
        $request .= '</params>';
        return $this->sendRequest($request);  
    }

    
    /*
     * Remove LNP request
     * 
     * @param (int) $port_number - the Port number
     * @return XML Object
     */
    public function deleteLnp($port_number)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<port_number>' . htmlspecialchars($port_number) . '</port_number>'; 
        $request .= '</params>';
        return $this->sendRequest($request);  
    }
    
    
    /*
     * Retrieve list all of the available states 
     * 
     * @return Object
     */
    public function faxListStates()
    {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }
    
    
    /*
     * Get Rate Centers list
     * 
     * @param (string) - state. Length - 2 chars  (MA, TX)
     * @return XML Object
     */
    public function faxListRatecenters($state = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<state>' . htmlspecialchars($state) . '</state>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }

    
    /*
     * List vFax DIDs  - local or Toll Free
     * 
     * To get Local DIDs list should use $ratecenter/$state  to get DIDs list
     * @param (string) $ratecenter - rate center name (ADAMS)
     * @param (string) $state - US state two chars (MA)
     * To get Toll Free DIDs list do not pas params
     */
    public function faxListAvailableDids($ratecenter = null, $state = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<ratecenter>' . htmlspecialchars($ratecenter) . '</ratecenter>'; 
        $request .= '<state>' . htmlspecialchars($state) . '</state>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
   
    /*
     * Assign another DID to vFax account
     * @param (int) $did - DID to order: Local or Toll Free
     * @param (string) $note - DID note. Optional
     */
    public function faxOrderDid($did, $note = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>';
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
    
   /*
     * Add or remove note(comment) to specific Fax DID
     */
    public function setFaxDidNote($did, $note='')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
     /*
     * Add / Remove Port Out Validation PIN to Fax DID
     * 
     * @param $did (int) - iFax  DID to set/unset PIN (must be active)
     * @param $pin (int) - Four digit PIN or empty to unset
     * @return XML Object
     */
    public function setFaxDidPin($did, $pin = 'none')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<pin>' . $pin . '</pin>'; 
        $request .= '</params>';

        return $this->sendRequest($request);
    }
    

    /*
     * List vFax DIDs assigned to the account
     */
    public function faxListDids()
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        return $this->sendRequest($request);   
    }
    

    /*
     * Delete DID from Fax account
     * @param (int) $did - vFax DID to remove: Local or Toll Free 
     */
    public function faxRemoveDid($did = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
    
    /*
     * Create  ifax  customer
     * 
     * @param (string) $name - Customer real name. Up to 48 chars
     * @param (string) $login - Customer access login. Up to 24 chars, alpha-numeric value
     * @param (string) $password - Customer access password.
     * @param (int) $did - Ordered active DID to assign to let user have an access to
     */
    public function faxCreateUser($name, $email, $login, $password, $did)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<name>' . $name . '</name>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '<login>' . $login . '</login>'; 
        $request .= '<password>' . $password . '</password>'; 
        $request .= '<did>' . $did . '</did>'; 
        $request .= '</params>';
        return $this->sendRequest($request);     
    }
 
    
    /*
     * Update iFax password
     * 
     * @param (int) $did - iFax DID to change password
     * @param (string) $password - iFax password
     * 
     */
    public function faxUpdatePassword($did, $password)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<password>' . $password . '</password>'; 
        $request .= '</params>';
        return $this->sendRequest($request);     
    }
    
    
    /*
     * Delete  delivermyfax.com  customer
     * 
     * @param (string) $login - Customer loagin to delete
     */
    public function faxDeleteUser($login)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';

        $request .= '<params>';
        $request .= '<login>' . $login . '</login>'; 
        $request .= '</params>';
        return $this->sendRequest($request);     
    }
    
    
    /*
     * Set Email to Fax Authorized Email
     * DEPRECIATED!!!!
     * 
     * @param (int) $did: DID to assign authorized Email
     * @param (string) $auth_email - Email address allowed to send faxes. 
     *                 Multiple Emails separated by commas
     *                 Set empty value to uunset authorized Email
     * 
      * @param (string) $forw_email - Email address to forward inbound faxes to. 
     *                 Multiple Emails separated by commas
     *                 Set empty value to uunset forwarding Email
     */
    public function faxAuthEmail($did, $auth_email= '', $forw_email= '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<auth_email>' . urlencode(htmlspecialchars($auth_email)) . '</auth_email>'; 
        $request .= '<forw_email>' . urlencode(htmlspecialchars($forw_email)) . '</forw_email>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    
    
    
    /*
     * Create Email settings
     *   
     *  @param (int) $did - DID to set Email properties
     *  @param (string) $email - Email to set properties
     *  @param (int) $send -  Email is allowed to send faxess. Values: 1 - allowed, 0 - disallowed
     *  @param (int) $send -  Email is allowed to forward inbound faxess. Values: 1 - allowed, 0 - disallowed
     */
    public function faxEmailAdd($did, $email, $send, $receive)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '<send>' . $send . '</send>'; 
        $request .= '<receive>' . $receive . '</receive>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }

    /*
     * List Emails and it properties
     * 
     *  @param (int) $did - DID to get Email config. Optional
     */
    public function faxEmailsList($did = '')     
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    
    /*
     * Update Email settings
     * 
     *  @param (int) $did - DID to set Email properties
     *  @param (string) $email -  Email to set properties
     *  @param (int) $send -  Email is allowed to send faxess. Values: 1 - allowed, 0 - disallowed
     *  @param (int) $send -  Email is allowed to forward inbound faxess. Values: 1 - allowed, 0 - disallowed
     */
    public function faxEmailEdit($did, $email, $send = 1, $receive = 1)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '<send>' . $send . '</send>'; 
        $request .= '<receive>' . $receive . '</receive>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    

    /*
     * Remove Email address config
     * 
     * @param (int) $did - DID to manage Email properties
     *  @param (string) $email -  Email to remove
     */
    public function faxEmailDelete($did, $email)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }

    

    /*
     * Sending fax
     * 
     * @param (int) $didfrom - sender fax number (10 digits)
     * @param (int) $didto - recipient fax number (10 digits)
     * @param (string) $name - recipient name or company name
     * @param (string) $file - full local path to file to send
     *  allowed file extentions and types:
     *      jpg - JPG Image; 
     *      pdf - Adobe PDF;
     *      ps -  Adobe PostScript;
     *      tif, tiff -  TIFF, 
     *      doc, docx - MS Word file;
     *      xls, csv -  Excel or CSV file
     *      htm, html - HTML page;
     *      txt -  Plain Text.
     */
    public function faxSend($didfrom = null, $didto = null, $name = null, $file_path = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<didfrom>' . htmlspecialchars($didfrom) . '</didfrom>'; 
        $request .= '<didto>' . htmlspecialchars($didto) . '</didto>';
        $request .= '<name>' . htmlspecialchars($name) . '</name>';

        if(is_file($file_path)) 
        {
            $request .= '<file>' . base64_encode( file_get_contents($file_path)) . '</file>';
            $request .= '<filename>' . basename($file_path) . '</filename>';
        }
        $request .= '</params>';
        
        return $this->sendRequest($request);   
    } 
    
    
    /*
     *  View Fax History
     * 
    @param (int) $did - Your fax to see fax history, all numbers by default
    @param (int | array) $period - Date range. 
        Values: (int) 0 (default) - today,
                (int) 1- yesterday, 
                (array) start time / end time. Example: array('2015-06-21 21:00:00', '2015-06-26 22:00:00')       
    @param (int) $type - Type of fax. 
        Values: (int) 0 (default) - All faxes: in/out, 
                 (int)1 - Outbound faxes only, 
                 (int)2 - Inbound faxes only 
    @param (int) $fax_id - Fax ID (provided on calling faxSend()  )
    @return XML Object
    */
    public function faxHistory($did = 'all', $period = 0, $type = 0, $fax_id = 0)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>'; 
        
        if(is_array($did))
        {
            foreach($did as $v) {
                $request .= '<did>' . htmlspecialchars($v) . '</did>'; 
            }
        } else {
            $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        }
        
        if(is_array($period))
        {
            foreach($period as $v) {
                $request .= '<period>' . $v . '</period>'; 
            }
        } else {
            $request .= '<period>' . $period . '</period>'; 
        }
            
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<fax_id>' . $fax_id . '</fax_id>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
    
    /*
     * Download fax (inboud or outbound)
     */
    public function faxDownload($fax_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';  
        $request .= '<params><fax_id>' . $fax_id . '</fax_id></params>'; 
        return $this->sendRequest($request);
    }
    
    
    
    // --------- iFax Enterprise ----------------//
    
    
    /*
     * Assign another DID to vFax account
     * @param (int) $did - DID to order: Local or Toll Free
     * @param (int) $group_id - Fax group to add the DID. Optional
     */
    public function fax2OrderDid($did, $note = '', $group_id = 0)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>';
        $request .= '<group_id>' . $group_id . '</group_id>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
        /*
     * List vFax DIDs assigned to the account
     */
    public function fax2ListDids($group_id = 0)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<group_id>' . $group_id . '</group_id>'; 
        $request .= '</params>';
        return $this->sendRequest($request);   
    }
    
    
    /*
     * Add or remove note(comment) to specific Fax DID
     */
    public function fax2SetDidNote($did, $note='')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Add or remove note(comment) to specific Fax DID
     */
    public function fax2SetDidPin($did, $pin='none')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<pin>' . $pin . '</pin>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Disable / Activate DID
     */
    public function fax2SetDidPending($did, $action='none')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<action>' . $action . '</action>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Delete DID from Fax account
     * @param (int) $did - vFax DID to remove: Local or Toll Free 
     */
    public function fax2RemoveDid($did = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    

    /*
     * Create iFax Group (company)
     */
    public function fax2GroupCreate($short_name, $long_name)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<short_name>' . htmlspecialchars($short_name) . '</short_name>'; 
        $request .= '<long_name>' . htmlspecialchars($long_name) . '</long_name>'; 
        $request .= '</params>';

        return $this->sendRequest($request);    
    }
    
    
    /*
     * List iFax Group (companies)
     * @param (int | array | null) $id - Fax Group ID. Optional
     */
    public function fax2GroupsList($group_id = null)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        if($group_id != null)
        {
            $request .= '<params>';
            if(is_array($group_id))
            {
                foreach($group_id as $v) {
                    $request .= '<group_id>' . $v . '</group_id>'; 
                }
            } else {
                $request .= '<group_id>' . $group_id . '</group_id>'; 
            }
            $request .= '</params>';
        }
        return $this->sendRequest($request); 
    }
    

    /*
     * Update iFax Group (company) name
     * @param (int) $group_id - Fax Group ID. 
     * @param (string) $short_name - Fax Group short name, up to 24 chars 
     * @param (string) $long_name - Fax Group short name, up to 128 chars 
     */
    public function fax2GroupEdit($group_id = '', $short_name = '', $long_name = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<group_id>' . $group_id . '</group_id>'; 
        $request .= '<short_name>' . $short_name . '</short_name>'; 
        $request .= '<long_name>' . $long_name . '</long_name>'; 
        $request .= '</params>';
  
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Remove iFax Group
     * @param (int) $group_id - Fax Group ID. 
     */
    public function fax2GroupDelete($group_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<group_id>' . $group_id . '</group_id>'; 
        $request .= '</params>';
  
        return $this->sendRequest($request); 
    }
    
    
    /*
     * @param (int) $group_od - Group id to add new customer to. Required
     * @param (string) $username - Fax username, Unique, mandatory.
     * @param (string) $pasword - Fax account password. Required.
     * @param (int) $is_admin - is user group admin. Required. Values: 1 - admin, 0 - regular user
     * @param (string) $first_name - customer the First Name. 
     * @param (string) $last_name - customer the Last Name.
     * @param (string) $email - customer contact Email. Optional
     */
    public function fax2UserCreate($group_id, $username, $password, $is_admin, $first_name, $last_name, $email)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<group_id>' . $group_id . '</group_id>'; 
        $request .= '<username>' . $username . '</username>'; 
        $request .= '<password>' . $password . '</password>'; 
        $request .= '<is_admin>' . $is_admin . '</is_admin>'; 
        $request .= '<first_name>' . $first_name . '</first_name>'; 
        $request .= '<last_name>' . $last_name . '</last_name>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '</params>';
  
        return $this->sendRequest($request); 
    }
    
    
    /*
     * List iFax users
     */
    public function fax2UsersList($group_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        if($user_id != null)
        {
            $request .= '<params>';
            if(is_array($group_id))
            {
                foreach($group_id as $v) {
                    $request .= '<group_id>' . $v . '</group_id>'; 
                }
            } else {
                $request .= '<groupr_id>' . $group_id . '</group_id>'; 
            }
            $request .= '</params>';
        }
        return $this->sendRequest($request); 
    }
    

    /*
     * @param (int) $user_od - user ID to update
     * @param (string) $username - Fax username, Unique. Required.
     * @param (string) $pasword - Fax account password. Required.
     * @param (int) $is_admin - is user group admin. Required. Values: 1 - admin, 0 - regular user
     * @param (string) $first_name - customer the First Name. 
     * @param (string) $last_name - customer the Last Name.
     * @param (string) $email - customer contact Email. Optional
     */
    public function fax2UserEdit($user_id, $username, $is_admin, $first_name, $last_name, $email)
    {
    
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<user_id>' . $user_id . '</user_id>'; 
        $request .= '<username>' . $username . '</username>'; 
        $request .= '<is_admin>' . $is_admin . '</is_admin>'; 
        $request .= '<first_name>' . $first_name . '</first_name>'; 
        $request .= '<last_name>' . $last_name . '</last_name>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '</params>';
  
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Update iFax Enterprise user password
     */
    public function fax2UserUpdatePasswd($user_id, $password)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<user_id>' . $user_id . '</user_id>'; 
        $request .= '<password>' . $password . '</password>'; 
        $request .= '</params>';
  
        return $this->sendRequest($request); 
    }

    
    /*
     * REmove iFax Enterprise user
     */
    public function fax2UserDelete($user_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<user_id>' . $user_id . '</user_id>'; 
        $request .= '</params>';
  
        return $this->sendRequest($request); 
    }


    /*
     * Create iFax Configuration item
     */
    public function fax2ConfigCreate($user_id, $did, $allow_send = 1, $allow_delete = 1, $allow_list_in = 1, $allow_list_out = 1)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<user_id>' . $user_id . '</user_id>'; 
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<allow_send>' . $allow_send . '</allow_send>'; 
        $request .= '<allow_delete>' . $allow_delete . '</allow_delete>'; 
        $request .= '<allow_list_in>' . $allow_list_in . '</allow_list_in>'; 
        $request .= '<allow_list_out>' . $allow_list_out . '</allow_list_out>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }


    /*
     * List ifax Enterprise configuration items
     */
    public function fax2ConfigList($did = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    
    
    /*
     * Update ifax Enterprise configuration item props
     */
    public function fax2ConfigEdit($config_id, $allow_send = 1, $allow_delete = 1, $allow_list_in = 1, $allow_list_out = 1)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<config_id>' . $config_id . '</config_id>'; 
        $request .= '<allow_send>' . $allow_send . '</allow_send>'; 
        $request .= '<allow_delete>' . $allow_delete . '</allow_delete>'; 
        $request .= '<allow_list_in>' . $allow_list_in . '</allow_list_in>'; 
        $request .= '<allow_list_out>' . $allow_list_out . '</allow_list_out>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    
    
    /*
     * Remove ifax Enterprise configuration item
     */
    public function fax2ConfigDelete($config_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<config_id>' . $config_id . '</config_id>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }

   /*
    * Add new authorized Email to DID 
    */
    public function fax2EmailAdd($did, $email, $send, $receive)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '<send>' . $send . '</send>'; 
        $request .= '<receive>' . $receive . '</receive>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    
    
    public function fax2EmailsList($group_id = '', $did = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<group_id>' . $group_id . '</group_id>'; 
        $request .= '<did>' . $did . '</did>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    
    
    public function fax2EmailsEdit($email_id, $email, $send = 1, $receive = 1)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<email_id>' . $email_id . '</email_id>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '<send>' . $send . '</send>'; 
        $request .= '<receive>' . $receive . '</receive>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }
    

    public function fax2EmailsDelete($email_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<email_id>' . $email_id . '</email_id>'; 
        $request .= '</params>'; 
        
        return $this->sendRequest($request);  
    }

    
    public function fax2Upload($file_path = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        if(!empty($file_path)) 
        {
            $request .= '<file>' . base64_encode( file_get_contents($file_path)) . '</file>';
            $request .= '<filename>' . basename($file_path) . '</filename>';
        }
        $request .= '</params>';
        
        return $this->sendRequest($request);   
    } 
    
    
    /*
     * Sending fax
     * 
     * @param (int) $didfrom - sender fax number (10 digits)
     * @param (int) $didto - recipient fax number (10 digits)
     * @param (string) $name - recipient name or company name
     * @param (string) $file - full local path to file to send
     *  allowed file extentions and types:
     *      jpg - JPG Image; 
     *      pdf - Adobe PDF;
     *      ps -  Adobe PostScript;
     *      tif, tiff -  TIFF, 
     *      doc, docx - MS Word file;
     *      xls, csv -  Excel or CSV file
     *      htm, html - HTML page;
     *      txt -  Plain Text.
     */
    public function fax2Send($didfrom = '', $didto = '',  $file_id = null )
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did_from>' . htmlspecialchars($didfrom) . '</did_from>'; 
        $request .= '<did_to>' . htmlspecialchars($didto) . '</did_to>';

        if(is_array($file_id))
        {
            foreach($file_id as $v) {
                $request .= '<file_id>' . $v . '</file_id>'; 
            }
        } else {
            $request .= '<file_id>' . $file_id . '</file_id>'; 
        }
        $request .= '</params>';
        
        return $this->sendRequest($request);   
    } 
    
     
    /*
     *  View Fax History
     * 
    @param (int) $did - Your fax to see fax history, all numbers by default
    @param (int | array) $period - Date range. 
        Values: (int) 0 (default) - today,
                (int) 1- yesterday, 
                (array) start time / end time. Example: array('2015-06-21 21:00:00', '2015-06-26 22:00:00')       
    @param (int) $type - Type of fax. 
        Values: (int) 0 (default) - All faxes: in/out, 
                 (int)1 - Outbound faxes only, 
                 (int)2 - Inbound faxes only 
    @param (int) $fax_id - Fax ID (provided on calling faxSend()  )
    @return XML Object
    */
    public function fax2History($did = 'all', $period = 0, $type = 0, $fax_id = 0)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>'; 
        
        if(is_array($did))
        {
            foreach($did as $v) {
                $request .= '<did>' . htmlspecialchars($v) . '</did>'; 
            }
        } else {
            $request .= '<did>' . htmlspecialchars($did) . '</did>'; 
        }
        
        if(is_array($period))
        {
            foreach($period as $v) {
                $request .= '<period>' . $v . '</period>'; 
            }
        } else {
            $request .= '<period>' . $period . '</period>'; 
        }
            
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<fax_id>' . $fax_id . '</fax_id>'; 
        $request .= '</params>';
        
        return $this->sendRequest($request);
    }
    
    
    /*
     * Download fax (inboud or outbound)
     */
    public function fax2Download($fax_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';  
        $request .= '<params><fax_id>' . $fax_id . '</fax_id></params>'; 
        return $this->sendRequest($request);
    }
    
  
    /*
     * Enable or disable DID for SMS service
     * 
     * @param (int) $did - Already ordered voice DID (see the API's  orderDID() method )
     * @param (bool) $action - Action to do. Values: enable / disable
     */
    public function smsManageDid($did, $action = 'enable')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<action>' . $action . '</action>'; 
        $request .= '</params>';
        return $this->sendRequest($request); 
    }


    /*
     * Assign or remove Email to forward SMS
     * 
     * @param (int) $did - DID to set up SMS forwarding 
     * @param (string) $email - Email address to forward SMS. Leave the param to remove forwarding
     * @param (string) $method - Set SMS sending methid. Values: none - Remove SMS forwarding, email - Email only, xmpp - XMPP only, both - Email and XMPP, url - post to URL
     * @param (string) $xmpp_name - Name of XMPP account. Required if method var is set to xmpp or both
     * @param (string) $xmpp_passwd - Password of XMPP account. Required if method var is set to xmpp or both
     * @params (string) $url - URL to poot SMS directly
     * the email argument has priority of xmpp in case of conflict
     */
    public function smsManageEmailForward($did, $email = '', $method = 'email', $xmpp_name = '', $xmpp_passwd = '', $url = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<did>' . $did . '</did>'; 
        $request .= '<email>' . $email . '</email>'; 
        $request .= '<method>' . $method  . '</method>';
        $request .= '<xmpp_name>' . $xmpp_name . '</xmpp_name>';
        $request .= '<xmpp_passwd>' . $xmpp_passwd . '</xmpp_passwd>';
        $request .= '<url>' . (!empty($url) ? urlencode($url) : '') . '</url>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }

 
    /*
     * Send SMS message
     * 
     * @param (int) $didfrom - SMS enabled DID from your account
     * @param (int) $didto - US based phone number (10 digits) to send SMS. 
     * @param (string) $msg - Message to send
     * @param (string) $file_path - Path to file to send (MMS). 
     */
    public function smsSend($didfrom, $didto, $msg, $file_path = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<didfrom>' . $didfrom . '</didfrom>'; 
        $request .= '<didto>' . $didto . '</didto>'; 
        $request .= '<msg>' . $msg . '</msg>'; 
        
        if(!empty($file_path) && is_file($file_path)) 
        {
            $request .= '<fname>' . base64_encode(basename($file_path)) . '</fname>'; 
            $request .= '<file>' . base64_encode( file_get_contents($file_path)) . '</file>'; 
        }

        $request .= '</params>';
        
       // print_r($request); die;
        
        return $this->sendRequest($request); 
    }
     
     
    /*
     * Add new server - dedicated or virtual
     * 
     * @param (string) $type - server type. Possible values: dedicated, virtual
     * @param (string) $note 
     * @return (int) id - service id
     */
    public function serverAdd($type, $note = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<note>' . $note . '</note>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }
    
    
    /*
     * List existing servers
     * 
     * @param (string) $type - server type. Possible values: dedicated, virtual
     * @param (string) $status - server status. Possible values: active, pending, all
     */
    public function serverList($type, $status = 'all')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<status>' . $status . '</status>';
        $request .= '</params>';

        return $this->sendRequest($request);    
    }
    

    /*
     * Remove dedicated or virtual server from account
     * 
     * @param (int) $id - server id
     */
    public function serverRemove($id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
    
    /*
     * Add new IP address to the list allowed to login (SSH) IP 
     * 
     * @param (int) $id - server to manage ID
     * @param (string) $ip - IP address to add to list of allowed IP
     */
    public function serverIpAdd($id, $ip)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '<ip>' . $ip . '</ip>'; 
        $request .= '</params>';   
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * IP addresses list allowed to connect to the server
     */
    public function serverIpList($id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '</params>';

        return $this->sendRequest($request);    
    }
    
    
    /*
     * Remove IP address from list allowed IP
     * 
     * @param (int) $id - server to manage ID
     * @param (string) $ip - IP address to remove
     */
    public function serverIpRemove($id, $ip)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '<ip>' . $ip . '</ip>'; 
        $request .= '</params>';

        return $this->sendRequest($request);  
    }
    
  
    /*
     * QuBe server order
     */
    
    /*
     * @param (string) $type - server type. Possible values: dedicated, virtual
     * @param (string) $note 
     * @return (int) id - service id
     */
    public function serverQubeAdd($type, $note = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<note>' . $note . '</note>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }
    
    
    /*
     * List existing QuVe servers
     * 
     * @param (string) $type - server type. Possible values: dedicated, virtual
     * @param (string) $status - server status. Possible values: active, pending, all
     */
    public function serverQubeList($type, $status = 'all')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<type>' . $type . '</type>'; 
        $request .= '<status>' . $status . '</status>';
        $request .= '</params>';

        return $this->sendRequest($request);    
    }
    
    
    /*
     * Remove Qube dedicated or virtual server
     * 
     * @param (int) $id - server id
     */
    public function serverQubeRemove($id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '</params>';

        return $this->sendRequest($request);   
    }
    
    
    /*
     * QuBe servers - Add new IP address to the list allowed to login (SSH) IP 
     * 
     * @param (int) $id - server to manage ID
     * @param (string) $ip - IP address to add to list of allowed IP
     * @param (string) $note - Your comment, note
     */
    public function serverQubeIpAdd($id, $ip, $note = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '<ip>' . $ip . '</ip>'; 
        $request .= '<note>' . htmlspecialchars($note) . '</note>'; 
        $request .= '</params>';   
        
        return $this->sendRequest($request); 
    }
    
    
    /*
     * QuBe servers - IP addresses list allowed to connect to the server
     */
    public function serverQubeIpList($id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '</params>';

        return $this->sendRequest($request);    
    }
    
    
    /*
     * QuBe servers - Remove IP address from list allowed IP
     * 
     * @param (int) $id - server to manage ID
     * @param (string) $ip - IP address to remove
     */
    public function serverQubeIpRemove($id, $ip)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<id>' . $id . '</id>'; 
        $request .= '<ip>' . $ip . '</ip>'; 
        $request .= '</params>';

        return $this->sendRequest($request);  
    }
    

   /*
    * Financial methods
    */
    
    public function accountGetBalance() {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
    }

 
    /*
     *  Allow / Forbid autorefill (enable alarm as well)
     * 
     *  @param (string) $autorefill enable /disable
     */
    public function accountSetRefill($autorefill = 'enable') 
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<autorefill>' . $autorefill . '</autorefill>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }

    
    /*
     *  Refill settings - manimal value, refill anmount
     * 
     *  @param (int) $minimum_balance - Minimal account balance. Possible values: 5, 25, 30, 35, 40, 45, 50
     *  @param (int) $reload_amount - Autoefill balance amount. Possible values:  25, 50, 60, 70, 80, 90, 100, 200, 300, 400, 500
     */  
    public function accountRefillConfig($minimum_balance = 5, $reload_amount = 25)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<minimum_balance>' . $minimum_balance . '</minimum_balance>'; 
        $request .= '<reload_amount>' . $reload_amount . '</reload_amount>'; 
        $request .= '</params>';

        return $this->sendRequest($request); 
    }

    
   /*
    * Refill account balance
    * 
    * @param (int) $amount - Amount to refill balance
    */
   public function accountRefill($amount = 10)
   {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<amount>' . $amount . '</amount>'; 
        $request .= '</params>';
        return $this->sendRequest($request); 
   }
    
   
   /*
    * Get account rates
    */
   public function accountRates()
   {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
   }
   
   
   /*
    * Support tickets
    */
   
   /*
    * Get IDs for last 20 tickets
    * @return Object
    */
    public function supportLastTicketsList() {
        return $this->sendRequest('<requestType>' . __FUNCTION__ . '</requestType>'); 
   }

   
    /*
     * View Support Ticket
     * 
     * @param (int) $ticket_id - Ticket ID to show posts
     */
    public function supportReadTicket($ticket_id)
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<ticket_id>' . $ticket_id . '</ticket_id>'; 
        $request .= '</params>';
        return $this->sendRequest($request); 
    }
    
    
    /*
     * Create Support Ticket or post new message in existing ticket
     * 
     * @param (string) $msg - Message 
     * @param (string) $subj - Message subject. For new ticket only
     * @param (int) $ticket_id - Ticket to add new post. If values eq to zero new ticket will be created
     * @param (string) $close_ticket - Set the ticked as closed. Values: yes / no - default
     * @param (sctring) $files - path to file to publish with post. Up to three files allowed to send.
     */
    public function supportCreatePost($msg = '', $subj = '', $ticket_id = 0, $close_ticket = 'no', $files = '')
    {
        $request = '<requestType>' . __FUNCTION__ . '</requestType>';
        $request .= '<params>';
        $request .= '<msg>' . htmlspecialchars($msg) . '</msg>'; 
        $request .= '<subj>' . htmlspecialchars($subj) . '</subj>';
        $request .= '<ticket_id>' . htmlspecialchars($ticket_id) . '</ticket_id>';
        $request .= '<close_ticket>' . htmlspecialchars($close_ticket) . '</close_ticket>';
        if(is_array($files))
        {
            foreach($files as $v)
            {
                if(is_file($v)) 
                {
                    $request .= '<files>';
                    $request .= '<name>' . basename($v) . '</name>'; 
                    $request .= '<cont>' . base64_encode( file_get_contents($v)). '</cont>'; 
                    $request .= '</files>';
                } 
            }
        }
        $request .= '</params>';
        return $this->sendRequest($request);  
    }

    
    // Internal methods
    
    /*
     * User authorization in API
     */
    protected function customerAuthentication() 
    {
         return '<customerAuthentication>' .
            '<login>' . LOGIN . '</login>' .
            '<password>' . PASSWORD . '</password>' .
            '<key>' . KEY . '</key>' .
            '</customerAuthentication>';
    }
    
    
    /*
     * Build dull XML request to server
     */
    protected function sendRequest($request)
    {
         $data = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" .
            "<apirequest xmlns=\"http://www.w3.org/1999/xhtml\">";
         $data .= $this->customerAuthentication();
         $data .= "<customerRequest>" . $request . "</customerRequest>";
         $data .= "</apirequest>";
         
        return CONNECT_TYPE == 'socket' ? $this->sendSocketRequest($data) : $this->sendCurlRequest($data);
    }
    
    
    /*
     * Sends the XML API request using CURL
     * 
     * @param String $request
     * @return Object 
     */
    private function sendCurlRequest($request) 
    {

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://' . HOST . PATH);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml", 'Content-Length: ' . strlen($request)));
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_USERAGENT, 'QB API');
        curl_setopt($ch, CURLOPT_POSTFIELDS, $request);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 45);
        curl_setopt($ch, CURLOPT_TIMEOUT, 45);

       // $response = trim(curl_exec($ch));
        $response = curl_exec($ch);
        //var_dump($response);  die;
        
        
        if(!$response) {
            return 'No response from API using CURL!';
        }
        curl_close($ch);
 
        return $this->clearResult( trim($response) );
    }
    
    
    /*
     * Sends the XML API request using socket.
     * @param String $request
     * @return Object 
     */
    private function sendSocketRequest($request) 
    {
        $header = "POST " . PATH . " HTTP/1.0\r\n";
        $header .= "Host: " . HOST . "\r\n";
        $header .= "User-Agent: QB API\r\n";
        $header .= "Content-Type: text/xml\r\n";
        $header .= "Content-length: " . strlen($request) . "\r\n\r\n";

        //$fp = fsockopen('ssl://'. HOST, 443, $errno, $errstr, 45); // Production
        $fp = fsockopen(HOST, 80, $errno, $errstr, 45); // Test

        if(!$fp) {
            return 'No response from API using socket!';
        }
        
        fputs($fp, $header . $request);

        $response = '';
        while (!feof($fp)) {
            $response .= fgets($fp,1024);
        }  
        fclose($fp);
        
        if(!$response) {
            return 'Can not connect to API server using socket!';
        }
        
          //var_dump($response);  die;
          
        return $this->clearResult( trim($response));
    }
    
    
    /*
     * Get content from response (cut headers)
     * 
     * @param String
     * @return Object
     */
    private function clearResult($response)
    {

        $len = strlen($response);
        $bodypos = strpos($response, "\r\n\r\n");
        
        if($bodypos <= 0) {
            $bodypos = strpos($response, "\n\n");
        }

        while($bodypos < $len && $response[$bodypos] != '<') {
            $bodypos++;
        }

        libxml_use_internal_errors(true);
        $result = simplexml_load_string( substr($response, $bodypos), 'SimpleXMLElement', LIBXML_NOCDATA ); 

        return  CLEAR_XML == true ? json_decode(json_encode($result)) : $result;
    }
 
}
?>